#! /usr/bin/env python2

import dispy
from math import ceil

# password length
# a Core 2 Duo E6550 takes about 15s to iterate over all length 4 passwords
length = 4 # password length

ascii = range(48,58)+range(65,91)+range(97,123)
nchars = len(ascii)
chars = ['%c' % j for j in ascii]

# small chunks achieve better concurrency
# workers can always request more work if they run out
chunk_size = 1
nchunks = int(ceil(nchars/float(chunk_size)))


# replace the next line with your desired hash, for example
# md5 of 'test' is
#target_hash_md5 = '098f6bcd4621d373cade4e832627b4f6'

target_hash_md5 = '392b2bd9f1571ff02e7dc21adfb2f0b0'

def md5cracker(chunk_start,chunk_end,chars,length,thash):
    import hashlib, itertools
    
    for j in range(chunk_start,chunk_end):
        for k in itertools.product(chars,repeat = length - 1):
            guess = chars[j] + ''.join(k)
            ghash = hashlib.md5(guess).hexdigest()
            if ghash == thash:
                return guess
    return False

def callback(job):    
    if job.result:
        print "Great victory!", job.result
        for j in jobs:
            if j.status in [dispy.DispyJob.Created, dispy.DispyJob.Running]:
                cluster.cancel(j)

        
if __name__ == '__main__':
    cluster = dispy.JobCluster(md5cracker,callback=callback)
    jobs = []
    start = 0
    for j in range(nchunks):
        end = start + chunk_size
        job = cluster.submit(start,end,chars,length,target_hash_md5)
        job.id = j
        start = end
        jobs.append(job)
    
    cluster.wait()
    cluster.stats()
    
    
