#from math import round

def weightedpartition(list ,ratio):
    """Returns the chunk sizes for list split according to ratio:
    ratio=[1,...,1] splits into equal chunks"""
    
    n = len(list)
    m = len(ratio)
    div = sum(ratio)
    frac = [0 for j in range(m)]
    rem = [0 for j in range(m)]
    
    for j in range(m):
        frac[j] = n * ratio[j] // div
        rem[j] = (n * ratio[j]) % div
            
    remainder = n - sum(frac)
    
    # Divide remaining items by remainder
    # Handles corner case where m > n
    
    while remainder > 0:
        maxrem = rem.index(max(rem))
        frac[maxrem] += 1
        rem[maxrem] = 0
        remainder -= 1
        
        
    return(frac)
        
